<?php

/*

Plugin Name: Simple Mail Address Encoder
Plugin URI: http://www.bannerweb.ch/unsere-leistungen/wordpress-dev/simple-mail-address-encoder/
Description: Automatically encodes every e-mail address on posts and pages to prevent spam. Simply decodes any previously encoded e-mail address by just clicking the mail link.
Version: 1.0
Author: Bannerweb GmbH
Author URI: http://www.bannerweb.ch/

*/


function smae_parse($str_content){
	
	// Filter mail addresses
	$str_content = preg_replace_callback('#<a.*href=[\'|"]mailto:.*[\'|"].*>.*</a>#', 'smae_replace_mail', $str_content);
	
	return $str_content;
}

function smae_replace_mail($arr_args){
	
 	$str_mailto = preg_replace('#<a(.*)href=[\'|"](.*)[\'|"](.*)>(.*)</a>#i', "$2", $arr_args[0]);
 	$str_mailto = str_replace('mailto:', '', $str_mailto);
 	$str_mailto = base64_encode($str_mailto);
 	
	$str_mail = preg_replace('#<a(.*)>(.*)</a>#i', "$2", $arr_args[0]);
	$str_mail_tmp = $str_mail;
	$str_mail = '';
	
	while(isset($str_mail_tmp{$nr})) {
	
	    $str_mail .= smae_replace_char($str_mail_tmp{$nr});
	    $nr++;
	}
	
	return '<a href="javascript:smae_decode(\''.$str_mailto.'\');">'.$str_mail.'</a>';
}

function smae_replace_char($char){
	
	$int_num = ord($char);
	$int_num = (strlen($int_num) < 2) ? '00'.$int_num : $int_num ;
	$int_num = (strlen($int_num) < 3) ? '0'.$int_num : $int_num ;
	
	return '&#'.$int_num.';';
}

function smae_js(){
	
 	
	$str_js = "
	
	var keyStr = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
	 	
 	function smae_decode(m){
 	
 		document.location.href='mailto:' + decode64(m);
 	}
 
	function decode64(input) {
	
		var output = '';
		var chr1, chr2, chr3 = '';
		var enc1, enc2, enc3, enc4 = '';
		var i = 0;
		  
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');
		  
		do {
			enc1 = keyStr.indexOf(input.charAt(i++));
			enc2 = keyStr.indexOf(input.charAt(i++));
			enc3 = keyStr.indexOf(input.charAt(i++));
			enc4 = keyStr.indexOf(input.charAt(i++));
			  
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			  
			output = output + String.fromCharCode(chr1);
			  
			if (enc3 != 64) {
			
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
			
				output = output + String.fromCharCode(chr3);
			}
			  
			chr1 = chr2 = chr3 = '';
			enc1 = enc2 = enc3 = enc4 = '';
		  
		} while (i < input.length);
		      
		return unescape(output);
	}";
	
	
	echo '<script type="text/javascript"> '.$str_js.' </script>';
}


# Run plugin if it is not called directly
# ---------------------------------------

if(defined('ABSPATH') and defined('WPINC')) {

	add_filter('the_content', 'smae_parse', 1, 1);
	add_action('wp_footer', 'smae_js', 10);
}

?>